<?php

declare(strict_types=1);

namespace App\Http\Session;
namespace App\Controller;
ini_set('post_max_size', '100M');
ini_set('upload_max_filesize', '100M');
// ini_set('memory_limit', '-1');
ini_set('max_execution_time', '0');
date_default_timezone_set("Asia/Kolkata");
error_reporting(0);

 header('Access-Control-Allow-Origin: *');
 header('Access-Control-Allow-Headers: *');
 header('Access-Control-Allow-Methods: *');
 header('Access-Control-Allow-Credentials: true');


	
//echo 'hello'; exit;
//use Cake\Http\ServerRequest;
use Cake\Cache\Cache;

use Cake\Http\Session\DatabaseSession;

use Cake\Core\Configure;
use Cake\Http\Exception\ForbiddenException;
use Cake\Http\Exception\NotFoundException;
use Cake\Http\Response;
use Cake\View\Exception\MissingTemplateException;
use Cake\Event\Event;
use Cake\Event\EventInterface;

// use Shapefile\Shapefile;
// use Shapefile\ShapefileException;
// use Shapefile\ShapefileReader;


use PhpOffice\PhpSpreadsheet\Spreadsheet; // ← PhpSpreadsheet class
use PhpOffice\PhpSpreadsheet\Writer\Xlsx; // ← PhpSpreadsheet class
use PhpOffice\PhpSpreadsheet\IOFactory;





//use Mailgun\Mailgun;
class StationDataController extends AppController 
{
	
	#var $uses = array('HierarchyLevel');
	
	#echo 'sdfsfd';die;
	
    public function beforeFilter(EventInterface  $event)
        {
            parent::beforeFilter($event);
			$data = $this->request->getData();
   		}

		function index()
		{
			echo 'Error:404. Page not found.';
			exit;
		}

		function returnErrorMsg($msg){
            $jsonData = array();
            $jsonData['Status'] = 'fail';
            $jsonData['Message'] = $msg;
            $result = json_encode($jsonData);
            return $result;    
        }
		   
      function aws(){
		$data = $this->request->getData();
		
		$result['Status'] = 'Fail';
		$required = array('ApiKey','StationId','DeviceDate');
		$auth = StationDataController::validateRequired($data,$required);

		if($auth){
			if($this->ApiKey == $data['ApiKey'])
			{ 	
				$checkFlag = false;
				if(isset($data['MobileNumber']) && strlen(trim($data['MobileNumber'])) == 10 && ctype_digit($data['MobileNumber'])){
					$checkFlag = true;
				}else{
					$msg = "Mobile number should be 10 digit numeric value";
					$result = StationDataController::returnErrorMsg($msg);
					echo $result; exit;
				}	
				#echo '<pre>';print_r($data);exit;
				$save = array();
				$save['StationId'] = trim($data['StationId']);
				$save['DeviceDate'] = trim($data['DeviceDate']);
				if(isset($data['MobileNumber']) && trim($data['MobileNumber'])!=''){
					$save['MobileNumber'] = trim($data['MobileNumber']);
				}
				if(isset($data['Battery']) && trim($data['Battery'])!=''){
					$save['Battery'] = trim($data['Battery']);
				}
				if(isset($data['HourlyRainfall']) && trim($data['HourlyRainfall'])!=''){
					$save['HourlyRainfall'] = trim($data['HourlyRainfall']);
				}
				if(isset($data['DailyRainfall']) && trim($data['DailyRainfall'])!=''){
					$save['DailyRainfall'] = trim($data['DailyRainfall']);
				}
				if(isset($data['AirTemperature']) && trim($data['AirTemperature'])!=''){
					$save['AirTemperature'] = trim($data['AirTemperature']);
				}
				if(isset($data['WindDirection']) && trim($data['WindDirection'])!=''){
					$save['WindDirection'] = trim($data['WindDirection']);
				}
				if(isset($data['WindSpeed']) && trim($data['WindSpeed'])!=''){
					$save['WindSpeed'] = trim($data['WindSpeed']);
				}
				if(isset($data['AtmosphericPressure']) && trim($data['AtmosphericPressure'])!=''){
					$save['AtmosphericPressure'] = trim($data['AtmosphericPressure']);
				}
				if(isset($data['Humidity']) && trim($data['Humidity'])!=''){
					$save['Humidity'] = trim($data['Humidity']);
				}
				if(isset($data['SunshineDuration']) && trim($data['SunshineDuration'])!=''){
					$save['SunshineDuration'] = trim($data['SunshineDuration']);
				}
				if(isset($data['SoilMoisture']) && trim($data['SoilMoisture'])!=''){
					$save['SoilMoisture'] = trim($data['SoilMoisture']);
				}
				if(isset($data['SoilTemperature']) && trim($data['SoilTemperature'])!=''){
					$save['SoilTemperature'] = trim($data['SoilTemperature']);
				}
				$save['type'] = 1;////1 for aws 2 for arg
				$save['status'] = 1;
				$save['create_date'] = date('Y-m-d H:i:s');
	
				$insertRes = $this->mongodb->aws_arg_data->insertOne($save);

				// $myfile = fopen("/var/www/html/input_data.txt", "a") or die("Unable to open file!");
				// $json_post = json_encode($data);
				// $date = date("Y-m-d H:i:s");
				// $txt = $json_post;
				// fwrite($myfile, "\n". $txt);
				// fclose($myfile);

				if($insertRes->getInsertedCount() > 0){
					$result['Status'] = 'Success';
					$result['Message'] = 'Successfully Inserted';
				}else{
					$result['Message'] = 'Something happened';
				}	
			}else
			{
				$result['Message'] = StationDataController::invalidApiKey();
			} 
		}
		else{
			$result['Message'] = StationDataController::invalidRequest();
		}
		StationDataController::echoResponse($result);
	  }

	  function arg(){
		$data = $this->request->getData();
		
		$result['Status'] = 'Fail';
		$required = array('ApiKey','StationId','DeviceDate');
		$auth = StationDataController::validateRequired($data,$required);

		if($auth){
			if($this->ApiKey == $data['ApiKey'])
			{ 	
				$checkFlag = false;
				if(isset($data['MobileNumber']) && strlen(trim($data['MobileNumber'])) == 10 && ctype_digit($data['MobileNumber'])){
					$checkFlag = true;
				}else{
					$msg = "Mobile number should be 10 digit numeric value";
					$result = StationDataController::returnErrorMsg($msg);
					echo $result; exit;
				}	
				#echo '<pre>';print_r($data);exit;
				$save = array();
				$save['StationId'] = trim($data['StationId']);
				$save['DeviceDate'] = trim($data['DeviceDate']);
				if(isset($data['MobileNumber']) && trim($data['MobileNumber'])!=''){
					$save['MobileNumber'] = trim($data['MobileNumber']);
				}
				if(isset($data['Battery']) && trim($data['Battery'])!=''){
					$save['Battery'] = trim($data['Battery']);
				}
				if(isset($data['HourlyRainfall']) && trim($data['HourlyRainfall'])!=''){
					$save['HourlyRainfall'] = trim($data['HourlyRainfall']);
				}
				if(isset($data['DailyRainfall']) && trim($data['DailyRainfall'])!=''){
					$save['DailyRainfall'] = trim($data['DailyRainfall']);
				}
				$save['type'] = 2;////1 for aws 2 for arg
				$save['status'] = 1;
				$save['create_date'] = date('Y-m-d H:i:s');
	
				$insertRes = $this->mongodb->aws_arg_data->insertOne($save);



				if($insertRes->getInsertedCount() > 0){
					$result['Status'] = 'Success';
					$result['Message'] = 'Successfully Inserted';
				}else{
					$result['Message'] = 'Something Happened';
				}	
			}else
			{
				$result['Message'] = StationDataController::invalidApiKey();
			} 
		}
		else{
			$result['Message'] = StationDataController::invalidRequest();
		}
		StationDataController::echoResponse($result);
	  }
	
	function noMethod()
	{
		echo 'Error:404. Page not found.';
		exit;
	}
	
	function validateNull($data,$var)
	{
		#var_dump($data[$var]);#exit;
		if(isset($data[$var]) && trim($data[$var])!= '' && $data[$var] != '' && $data[$var] !== 'null' && $data[$var] !== NULL)
		{
			return true;
		}
		return false;
	}
	
	function validateRequired($data,$variables)
	{
		$reponse = true;
		foreach($variables as $val)
		{
			#print_r($val);exit;
			if(!StationDataController::validateNull($data,$val))
			{
				//echo $val;
				$reponse = false;
			}
		}
		#exit;
		return $reponse;
	}
	
	
	function echoResponse($result)
	{
		echo json_encode($result);	
		exit;
	}
	function invalidRequest()
	{
		return 'Invalid Request';
	}
	
	function invalidApiKey()
	{
		return 'Invalid Api key';
	}
	

}

?>
